(*
  objects.ml
  contains various object syntax forms to test ocaml+twt
*)

module Shape = struct
  class virtual t =
  object(self)
    method virtual area : unit -> float
    method to_string () =
     "shape with area " ^ (string_of_float (self#area ()))
    initializer
     print_endline "created a shape"

  class circle radius =
    let pi = 3.14159 in
     object
      inherit t
      method area () =
       pi *. radius *. radius

  class square sidelen = object
    inherit t
    method area () =
     sidelen *. sidelen

let c = new Shape.circle 2.0
let s = new Shape.square 4.0

print_endline (c#to_string ())
print_endline (s#to_string ())

class type to_string_able = object
  val to_string : unit -> string

ignore (s :> to_string_able)
